// scripts.js

// Globals

var refresh = 0;		// holds the Milliseconds of the refresh-interval
var buddyname = null;		// name of the buddy
var buddyIsOnline = false;
var serverresponse = null;		// response of oscar.aol.com
var interval = null;
var req = false;

function showVersion() {
	document.getElementById('infospan').innerHTML = "v0.1";
}


// Dashboard Setup by Apple (creates the "done" button)
function setup() {
	if(window.widget) {
		widget.onshow = onShow;
		widget.onhide = onHide;
	}
	
	exitflip();
	createGenericButton(document.getElementById("done"), "done", savePrefs);
	buddyname = getBuddyName();
	refresh = getRefreshTime();
	checkState();
	
	if(refresh > 1000)
		interval = setInterval("checkState()", refresh);
}




/*
 * Main functions
 */

function HTTPRequest(url) {

	// test for native XMLHttpRequest object
	if(window.XMLHttpRequest) {
		try {
			req = new XMLHttpRequest();
		} catch(e) {
			req = false;
		}
	}
	
	// process
	if(req) {
		req.onreadystatechange = processReqChange;
		req.open("GET", url, true);
		req.setRequestHeader("Cache-Control", "no-cache");
		
		req.send(null);
		return 1;
	}
	return 0;
}

function processReqChange() {
	
	// only if req shows "loaded" ( == state 4) and status is "OK" (200)
	if(req.readyState == 4) {
		if((req.status >= 200) && (req.status < 400)) {
			serverresponse = encodeURI(req.responseText.substring(10, 20));
			buddyIsOnline = (serverresponse == "%C3%BD%C3%BB%C3%95%C3%91%C3%81%C3%9A%C2%AB%03%C2%A2%C2%93");
			setState(buddyIsOnline ? "online" : "offline");
		}
		else {
			alert("There was a problem retrieving the data from the server (" + req.status + "): " + req.statusText);
			serverresponse = null;
			buddyIsOnline = false;
			setState("noresponse");
		}
	}
}


function checkState() {
	setState("checking");
	
	if(!buddyname)
		buddyname = getBuddyName();
	
	if(buddyname)
		HTTPRequest("http://big.oscar.aol.com/" + buddyname + "?on_url=http://www.google.com/nav_page.gif&off_url=http://www.google.com/nav_current.gif");
	else
		setState("nobuddy");
}


function getState() {
	return buddyIsOnline;
}


function setState(state) {
	var obj = document.getElementById("the_buddy");
	var bg_left = document.getElementById("buddy_left").style;
	var bg_middle = document.getElementById("buddy_middle").style;
	var bg_right = document.getElementById("buddy_right").style;
	
	switch(state) {
		case "checking":
			obj.innerHTML = "checking...";
			adjustSize(140);
			obj.setAttribute("class", "checking");
			bg_left.backgroundImage = "url(Images/orange_left.png)";
			bg_middle.backgroundImage = "url(Images/orange_middle.png)";
			bg_right.backgroundImage = "url(Images/orange_right.png)";
			break;
		
		case "online":
			obj.innerHTML = buddyname;
			adjustSize();
			obj.setAttribute("class", "online");
			obj.setAttribute("onclick", "openChat('" + buddyname + "');");
			bg_left.backgroundImage = "url(Images/green_left.png)";
			bg_middle.backgroundImage = "url(Images/green_middle.png)";
			bg_right.backgroundImage = "url(Images/green_right.png)";
			break;
		
		case "offline":
			obj.innerHTML = buddyname;
			adjustSize();
			obj.setAttribute("class", "offline");
			obj.setAttribute("onclick", "checkState();");
			bg_left.backgroundImage = "url(Images/red_left.png)";
			bg_middle.backgroundImage = "url(Images/red_middle.png)";
			bg_right.backgroundImage = "url(Images/red_right.png)";
			break;
		
		case "nobuddy":
			obj.innerHTML = "no buddy";
			adjustSize(140);
			obj.setAttribute("class", "unknown");
			bg_left.backgroundImage = "url(Images/gray_left.png)";
			bg_middle.backgroundImage = "url(Images/gray_middle.png)";
			bg_right.backgroundImage = "url(Images/gray_right.png)";
			break;
		
		case "noresponse":
			obj.innerHTML = "no response";
			adjustSize(154);
			obj.setAttribute("class", "unknown");
			bg_left.backgroundImage = "url(Images/gray_left.png)";
			bg_middle.backgroundImage = "url(Images/gray_middle.png)";
			bg_right.backgroundImage = "url(Images/gray_right.png)";
			break;
			
		default:
			return 0;
	}
}

function openChat(buddy) {
	if(window.widget) {
		//var openAS = "tell application \"iChat\"\n\tactivate\n\tdelay 3\n\tsend \"hello\" to (accounts where handle is \"" + buddy + "\")\nend tell";
		//var AS = widget.system("/usr/bin/osascript -e '" + openAS + "'" , null).status;
		var AS = widget.openApplication("com.apple.iChat");
		return !AS;
	}
	return 0;
}









/*
 * Pref functions
 */

function adjustPrefs() {
	var form = document.forms[0];
	
	// Buddy name
	buddyname = buddyname ? buddyname : getBuddyName();
	form.elements['buddyname'].value = buddyname;
	
	// Timer
	addRefreshPossibilities();
}

function getBuddyName() {
	if(window.widget)
		var value = widget.preferenceForKey(prefKey('buddyname'));
	
	return value ? value : "";
}

function getRefreshTime() {
	if(window.widget)
		var value = widget.preferenceForKey(prefKey('refresh'));
	
	return value ? value * 1000 : 0;
}

function addRefreshPossibilities() {
	//alert("addRefreshPossibilities() called");
	
	var selector = document.forms[0].selector;
	var possarr = new Array();
	possarr[5] = "5 seconds";
	possarr[10] = "10 seconds";
	possarr[20] = "20 seconds";
	possarr[60] = "minute";
	possarr[300] = "5 minutes";
	possarr[600] = "10 minutes";
	possarr[1800] = "half hour";
	possarr[3600] = "hour";
	
	selector.appendChild(document.createElement("option"));
	selector.lastChild.value = "0";
	selector.lastChild.innerHTML = "refresh manually (click the widget to refresh)";
	selector.appendChild(document.createElement("option"));
	selector.lastChild.value = "";
	selector.lastChild.innerHTML = "---";
	
	for(var seconds in possarr) {
		selector.appendChild(document.createElement("option"));
		selector.lastChild.value = seconds;
		selector.lastChild.innerHTML = "Check every " + possarr[seconds];
		selector.lastChild.selected = (refresh == seconds * 1000);		// select the right one
	}
}

function removePossibilities() {
	var selector = document.forms[0].selector;
	
	var startlen = selector.childNodes.length;
	for(i = 0; i < startlen; i++) {
		selector.removeChild(selector.options[0]);
	}
}

function prefKey(key) {
	if(window.widget)
		return widget.identifier + "_" + key;
	else
		return key;
}








/*
 * Turnaround and Dance
 */

function adjustSize(force) {
	var optsize;
	
	if(buddyname.length > 1)
		optsize = (buddyname.length * 11) + 34;
	else
		optsize = 140;
	
	optsize = force ? force : optsize;
	document.getElementById("front").style.width = optsize + "px";
}

function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	adjustPrefs();		// creates the option-menu to select the refresh-time
	showVersion();		// sets version-number
	
	if(window.widget)
		widget.prepareForTransition("ToBack");
	
	if(interval) {
		clearInterval(interval);
		interval = null;
	}
				
	front.style.display = "none";
	back.style.display = "block";
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);  
}


function savePrefs() {
	var form = document.forms[0];
	
	var refr = form.selector.options[selector.selectedIndex].value ? form.selector.options[selector.selectedIndex].value : 0;
	var buddy = form.elements['buddyname'].value ? form.elements['buddyname'].value.replace(/\s+/, "") : "";
	
	refresh = refr * 1000;
	buddyname = buddy;
	
	if(window.widget) {
		widget.setPreferenceForKey(buddy, prefKey('buddyname'));
		widget.setPreferenceForKey(refr, prefKey('refresh'));
		alert('setting YAAOSC-prefs: buddyname=' + buddy + ' refresh=' + refr);
	}
	
	hidePrefs();
}


function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if(window.widget)
		widget.prepareForTransition("ToFront");
	
	//document.getElementById("fliprollie").style.display = "none";	
	front.style.display = "block";
	back.style.display = "none";
	
	checkState();
	if(refresh > 1000)
		interval = setInterval("checkState()", refresh);
	
	removePossibilities();		// will be re-created next time the prefs are called
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
}






function onShow() {
	checkState();
	
	if(refresh > 1000)
		interval = setInterval("checkState()", refresh);
}

function onHide() {
	if(interval) {
		clearInterval(interval);
		interval = null;
	}
}


/*
 * i-Button by Apple
 */

var flipShown = false;
var animation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null };

function mousemove(event) {
	if(!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit(event) {
	if(flipShown) {
		
		// fade out the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer	= null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3(a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
	return from + (to - from) * ease;
}


// these functions are called when the info button itself receives onmouseover and onmouseout events (by Apple)

function enterflip(event) {
	document.getElementById("fliprollie").style.display = "block";
}

function exitflip(event) {
	document.getElementById("fliprollie").style.display = "none";
}

